precision mediump float;		//Ĭϸ㾫
varying vec2 vTextureCoord;			//մӶɫݹ
varying vec3 fNormal;    			//մӶɫݹķ
varying vec3 ftNormal;   				//մӶɫݹ
varying vec3 vPosition;  				//մӶɫݹĶλ
uniform sampler2D sTextureWg;		//ݣۣ
uniform sampler2D sTextureNormal;		//ݣߣ
uniform mat4 uMMatrix; 				//任
uniform vec3 uCamera;				//λ
uniform vec3 uLightLocationSun;		//Դλ
void pointLight(					//λռķ
  in vec3 normal,				//Ŷ
  out vec4 ambient,				//ջǿ
  out vec4 diffuse,				//ɢǿ
  out vec4 specular,				//վǿ  
  in vec3 vp,					//任׼ϵı㵽Դλõ
  in vec3 eye,					//任׼ϵ
  in vec4 lightAmbient,			//ǿ
  in vec4 lightDiffuse,			//ɢǿ
  in vec4 lightSpecular			//ǿ
){   
  ambient=lightAmbient; 						//ֱӵóǿ  
  vec3 halfVector=normalize(vp+eye);			//ߵİ    
  float shininess=50.0;						//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(normal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;			//ɢǿ
  float nDotViewHalfVector=dot(normal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    		//㾵ǿ	
}
void main(){   
   vec4 ambient,diffuse,specular;	  //ͨǿȵı 
   vec4 normalColor = texture2D(sTextureNormal, vTextureCoord); //ӷͼжֵ
   //ֵָ-1+1Χ
   vec3 cNormal=vec3(2.0*(normalColor.r-0.5),2.0*(normalColor.g-0.5),2.0*(normalColor.b-0.5));   
   cNormal=normalize(cNormal);   //Ŷ
   //任ķ
   vec3 normalTarget=vPosition+fNormal;
   vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*vec4(vPosition,1)).xyz;
   newNormal=normalize(newNormal);  
   //任 
   vec3 tangentTarget=vPosition+ftNormal;
   vec3 newTangent=(uMMatrix*vec4(tangentTarget,1)).xyz-(uMMatrix*vec4(vPosition,1)).xyz;
   newTangent=normalize(newTangent);    
   vec3 binormal=normalize(cross(newTangent,newNormal));	//㸱
   //任󣬴˾ڽ
   //ʵϵ任׼ϵ
   mat3 rotation=mat3(newTangent,binormal,newNormal);    
   vec3 newPosition=(uMMatrix*vec4(vPosition,1)).xyz; 		//任ƬԪλ   
   vec3 vp= normalize(uLightLocationSun-newPosition);		//㵽Դλõvp
   vp=normalize(rotation*vp);							//任vp 	
   //ӱ㵽б任  				  
   vec3 eye= normalize(rotation*normalize(uCamera-newPosition));
   pointLight(cNormal,ambient,diffuse,specular,vp,eye,
   	vec4(0.05,0.05,0.05,1.0),vec4(1.0,1.0,1.0,1.0),vec4(0.3,0.3,0.3,1.0));   
   vec4 finalColor=texture2D(sTextureWg, vTextureCoord);	//ƬԪɫֵ 
   //ۺͨǿȼƬԪɫƬԪɫݸ
   gl_FragColor = finalColor*ambient+finalColor*specular+finalColor*diffuse;
}        
